           LIST        P=PIC16F84A
           __CONFIG    H'3FF1'     ;  B'11111111110001' -  , 
                                   ;      , 
                                   ; WDT ,   

;===============================================================================================
;     .
W          EQU         H'0000'
F          EQU         H'0001'
;===============================================================================================

;===============================================================================================
;     . 
INTCON     EQU         H'000B'
STATUS     EQU         H'0003'
TRISA      EQU         H'0005'
TRISB      EQU         H'0006'
PORTA      EQU         H'0005'
PORTB      EQU         H'0006'
PC         EQU         H'0002'
;===============================================================================================

;===============================================================================================
;       ( /)
EEData      equ        08h         ; EEPROM - 
EECon1      equ        08h         ; EECON1 - 1.
EEAdr       equ        09h         ; EEPROM - 
EECon2      equ        09h         ; EECON2 - 1.
;===============================================================================================

;===============================================================================================
;   .       .
RP0        EQU         H'0005'     ;  5-   STATUS  RP0.
PRIEM      EQU         H'000C'     ; - 
Reg_1      EQU         H'000D'     ;   
Reg_2      EQU         H'000E'     ;   
Reg_3      EQU         H'000F'     ;   
S_Reg      EQU         H'0010'     ;  8   
ETALL      EQU         H'0011'     ;   "  "  
BUFER      EQU         H'0012'     ;     
;===============================================================================================

;===============================================================================================

           org         0           ;  

;===============================================================================================
;  
START      clrf        INTCON      ;   .
           bsf         STATUS,RP0  ;    1 , .. TRISA  TRISB   1

           movlw       b'00011100' ;     (RA2,RA3,RA4 )
           movwf       TRISA       ; ..       
                                   ;          -
           clrf        TRISB       ;       ,  

           bcf         STATUS,RP0  ;   0

           clrf        PORTA       ; ,      . 0
           clrf        PORTB       ; ,      . 0

;===============================================================================================

RABOTA     movlw       .10
           movwf       S_Reg       ;  -   
           call        SKAN        ; 

           
AN_1       goto        READ
ANALIZ     movf        PRIEM, W    ;    W   PRIEM
           bcf         STATUS,2    ;   Z = 0
           xorwf       ETALL,F     ;  
           btfsc       STATUS,2    ;  ,  

           goto        INDIK       ;    
           goto        AN_1        ;     -   

;===============================================================================================
;  INDIK -   (/)
INDIK      movf        S_Reg, W    
           addwf       PC,F        
           retlw       0           ;     , .. S_reg  .. =0
           goto        Ind_8       ; 7
           goto        Ind_7       ; 7
           goto        Ind_6       ; 6
           goto        Ind_5       ; 5
           goto        Ind_4       ; 4
           goto        Ind_3       ; 3
           goto        Ind_2       ; 2
           goto        Ind_1       ; 1
           goto        Ind_0       ; 0

Ind_8      btfss       PORTB,0
           goto        ON_8
           goto        OF_8
ON_8       bsf         PORTB,0
           goto        RABOTA
OF_8       bcf         PORTB,0
           goto        RABOTA

Ind_7      btfss       PORTB,7
           goto        ON_7
           goto        OF_7
ON_7       bsf         PORTB,7
           goto        RABOTA
OF_7       bcf         PORTB,7
           goto        RABOTA

Ind_6      btfss       PORTB,6
           goto        ON_6
           goto        OF_6
ON_6       bsf         PORTB,6
           goto        RABOTA
OF_6       bcf         PORTB,6
           goto        RABOTA

Ind_5      btfss       PORTB,3
           goto        ON_5
           goto        OF_5
ON_5       bsf         PORTB,3
           goto        RABOTA
OF_5       bcf         PORTB,3
           goto        RABOTA

Ind_4      btfss       PORTB,2
           goto        ON_4
           goto        OF_4
ON_4       bsf         PORTB,2
           goto        RABOTA
OF_4       bcf         PORTB,2
           goto        RABOTA

Ind_3      btfss       PORTB,1
           goto        ON_3
           goto        OF_3
ON_3       bsf         PORTB,1
           goto        RABOTA
OF_3       bcf         PORTB,1
           goto        RABOTA

Ind_2      btfss       PORTB,4
           goto        ON_2
           goto        OF_2
ON_2       bsf         PORTB,4
           goto        RABOTA
OF_2       bcf         PORTB,4
           goto        RABOTA

Ind_1      btfss       PORTB,5
           goto        ON_1
           goto        OF_1
ON_1       bsf         PORTB,5
           goto        RABOTA
OF_1       bcf         PORTB,5
           goto        RABOTA

Ind_0      movlw       0           ;    W  0
           bcf         STATUS,2    ;   Z = 0
           xorwf       PORTB,F     ;  
           btfsc       STATUS,2    ;  ,             
           goto        VOST1       ;    
           goto        VOST2       ;     -  

VOST1      movf        BUFER,W
           movwf       PORTB       
           goto        RABOTA

VOST2      movf        PORTB,W
           movwf       BUFER
           clrf        PORTB
           goto        RABOTA

;===============================================================================================
;   
SKAN
;       ""  
;delay = 113'778 machine cycles
OP_1        movlw       .255
            movwf       Reg_1
            movlw       .90
            movwf       Reg_2
;   
wr_1        btfss       PORTA,4    
            goto        OP_2
;     (   )
            btfss       PORTA,2     ;    ,   KN_1
            goto        KN_1
            goto        KN_0
KN_1        btfss       PORTA,2     ;   ,     
            goto        KN_1
            goto        KN_2        ;    ()

KN_0        decfsz      Reg_1, F
            goto        wr_1
            decfsz      Reg_2, F
            goto        wr_1       ;      
            goto        OP_1       ;       
                                   
;  ,   -    ""   
;delay = 24'981 machine cycles
OP_2        movlw       .112
            movwf       Reg_1
            movlw       .33
            movwf       Reg_2
wr_2        decfsz      Reg_1, F
            goto        wr_2
            decfsz      Reg_2, F
            goto        wr_2

;   
;delay = 88'797 machine cycles
            movlw       .225
            movwf       Reg_1
            movlw       .117
            movwf       Reg_2
wr_3        btfss       PORTA,4     ;  
            goto        OP_3
            decfsz      Reg_1, F
            goto        wr_3
            decfsz      Reg_2, F
            goto        wr_3
            goto        OP_1        ;   

;    6  +     
;delay = 14'244 machine cycles
OP_3        movlw       .126
            movwf       Reg_1
            movlw       .19
            movwf       Reg_2
wr_4        decfsz      Reg_1, F
            goto        wr_4
            decfsz      Reg_2, F
            goto        wr_4

;     - (  )
            clrf        PRIEM       ;   PRIEM

            btfsc       PORTA,4
            bsf         PRIEM,7
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,6
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,5
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,4
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,3
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,2
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,1
            call        Pause

            btfsc       PORTA,4
            bsf         PRIEM,0
            call        Pause

;   
;delay = 119'467 machine cycles
OP_4        movlw       .37
            movwf       Reg_1
            movlw       .156
            movwf       Reg_2
wr_7        
            btfss       PORTA,4    
            goto        OP_4
            decfsz      Reg_1, F
            goto        wr_7
            decfsz      Reg_2, F
            goto        wr_7

            retlw       .0          ;    SKAN          

;delay = 1'778 machine cycles
Pause       movlw       .77
            movwf       Reg_1
            movlw       .3
            movwf       Reg_2
wr_5        decfsz      Reg_1, F
            goto        wr_5
            decfsz      Reg_2, F
            goto        wr_5
            retlw       .0          ;    



;===============================================================================================
;     
KN_2        call        SKAN       ; c 

;     
            movf        PRIEM,W    ;     
            movwf       PORTB

;   
;delay = 500'000 machine cycles
            movlw       .85
            movwf       Reg_1
            movlw       .138
            movwf       Reg_2
            movlw       .3
            movwf       Reg_3
wr_6        
;        (   )
            btfss       PORTA,2     ;    ,   KNO_1
            goto        KNO_1
            goto        KNO_0
KNO_1       btfss       PORTA,2     ;   ,     
            goto        KNO_1
            goto        KNO_2       ;

;    
KNO_0       decfsz      Reg_1, F
            goto        wr_6
            decfsz      Reg_2, F
            goto        wr_6
            decfsz      Reg_3, F
            goto        wr_6

            clrf        PORTB       ; ,      . 0
            goto        KN_2        ;    ,        

;===============================================================================================
KNO_2       
;       EEPROM ()
WRITE       clrf       INTCON      ;   .
 
            movf       S_Reg,W     ;    W  S_Reg.
            movwf      EEAdr       ;     W   EEAdr.
 
            movf       PRIEM,W     ;     PRIEM   W.
            movwf      EEData      ;     W   EEPROM   S_Reg.

            bsf        STATUS,RP0  ;    .
            bsf        EECon1,2    ;  . 
                                    
            movlw      055h        ; 
            movwf      EECon2      ; 
            movlw      0AAh        ;  .
            movwf      EECon2      ; ----"----
            bsf        EECon1,1    ; ----"----

            bcf        EECon1,4    ;        EEPROM.
            bcf        STATUS,RP0  ;    .


            decfsz     S_Reg, F    ;    
            goto       KN_2        ;   EEPROM ()       
            goto       START

;===============================================================================================
;      
READ        bcf        STATUS,RP0  ;    .

            movf       S_Reg,W     ;    W  S_Reg.
            movwf      EEAdr       ;     W   EEAdr.

            bsf        STATUS,RP0  ;    .
            bsf        EECon1,0    ;  .
            bcf        STATUS,RP0  ;    .

            movf       EEData,W    ;     EEPROM   S_Reg   W.
            movwf      ETALL       ;     W   ETALL.

            decfsz     S_Reg, F    ;    
            goto       ANALIZ
            goto       RABOTA      ;  0 -   

;===============================================================================================

           end
